<script lang="ts">
    import { getBillOrdersAPI } from "src/apis/get-bill-orders";
    import { numberWithCommas } from "src/functions/comma-number";
    import { convertFullTime } from "src/functions/convert-time-th";
import type { BillOrderModel } from "src/models/bill.order.type";
    import { Page } from "src/page";

    import {
        billOrderListStore,
billOrderStore,
pageBackStore,
                                pageSelectedStore,
        userProfileStore,
    } from "src/store";
    import { onMount } from "svelte";

    $billOrderListStore = [];

    onMount(async () => {
        await getBillOrdersAPI($userProfileStore.userId);
    });

    function printBill(billOrder: BillOrderModel) {
        $billOrderStore = billOrder;
        $pageBackStore = $pageSelectedStore;
        $pageSelectedStore = Page["PRINT_SLIP_BANK_PAYMENT"];
    }
</script>

<div class="mx-auto w-2/3 h-full flex flex-col">
    {#if $billOrderListStore && $billOrderListStore.length}
        {#each $billOrderListStore as billOrder}
            <div class="bg-white rounded mt-5">
                <div class="px-5 pt-5 pb-0 leading-4 text-gray-800">
                    <div class="text-gray-800">
                        <div class="flex justify-between items-center mb-2">
                            <div class="flex-1" style="min-width: 0.625rem;" />
                            <div
                                class="mr-2 border-r border-gray-300 border-solid"
                            >
                                <div
                                    class="pr-1 no-underline bg-transparent cursor-pointer flex"
                                >
                                    <svg
                                        xmlns="http://www.w3.org/2000/svg"
                                        class="h-5 w-5 text-gray-500"
                                        viewBox="0 0 20 20"
                                        fill="currentColor"
                                    >
                                        <path
                                            fill-rule="evenodd"
                                            d="M18 10a8 8 0 11-16 0 8 8 0 0116 0zm-7-4a1 1 0 11-2 0 1 1 0 012 0zM9 9a1 1 0 000 2v3a1 1 0 001 1h1a1 1 0 100-2v-3a1 1 0 00-1-1H9z"
                                            clip-rule="evenodd"
                                        />
                                    </svg>
                                    <span class="align-middle pl-3"
                                        >{billOrder.statusOrder}</span
                                    >
                                </div>
                            </div>
                            <div
                                class="leading-6 text-right text-red-600 uppercase whitespace-no-wrap"
                            >
                                วันที่ทำรายการ {convertFullTime(
                                    +new Date(billOrder?.createTime || 0)
                                )}
                            </div>
                        </div>
                        <div
                            class="text-sm leading-5 border-t border-gray-300 border-solid"
                        >
                            {#each billOrder?.productList as product}
                                <div
                                    class="no-underline bg-transparent cursor-pointer"
                                >
                                    <div
                                        class="flex break-words border-b border-gray-300 border-solid flex-no-wrap"
                                        style="overflow-wrap: break-word;"
                                    >
                                        <div
                                            class="flex-auto select-none"
                                            style="min-width: 0px; overflow-wrap: break-word;"
                                        >
                                            <div
                                                class="flex py-2 px-0 select-none flex-no-wrap"
                                                style="overflow-wrap: break-word;"
                                            >
                                                <div
                                                    class="flex-shrink-0 mr-3 w-20 h-20"
                                                    style="overflow-wrap: break-word;"
                                                >
                                                    <div
                                                        class="relative w-full h-full"
                                                        style="overflow-wrap: break-word;"
                                                    >
                                                        <div
                                                            class="relative w-full h-full bg-gray-100"
                                                            style="overflow-wrap: break-word;"
                                                        >
                                                            <svg
                                                                enable-background="new 0 0 15 15"
                                                                viewBox="0 0 15 15"
                                                                x="0"
                                                                y="0"
                                                                class="inline-block absolute w-4 h-4 text-2xl font-normal leading-8"
                                                                style="fill: currentcolor; top: 50%; left: 50%; transform: translate(-50%, -50%); stroke: rgb(198, 198, 198); overflow-wrap: break-word;"
                                                            >
                                                                <g
                                                                    class=""
                                                                    style="overflow-wrap: break-word;"
                                                                >
                                                                    <rect
                                                                        fill="none"
                                                                        height="8"
                                                                        stroke-linecap="round"
                                                                        stroke-linejoin="round"
                                                                        stroke-miterlimit="10"
                                                                        width="10"
                                                                        x="1"
                                                                        y="4.5"
                                                                        class=""
                                                                        style="overflow-wrap: break-word;"
                                                                    />
                                                                    <line
                                                                        fill="none"
                                                                        stroke-linecap="round"
                                                                        stroke-linejoin="round"
                                                                        stroke-miterlimit="10"
                                                                        x1="1"
                                                                        x2="11"
                                                                        y1="6.5"
                                                                        y2="6.5"
                                                                        class=""
                                                                        style="overflow-wrap: break-word;"
                                                                    />
                                                                    <rect
                                                                        fill="none"
                                                                        height="3"
                                                                        stroke-linecap="round"
                                                                        stroke-linejoin="round"
                                                                        stroke-miterlimit="10"
                                                                        width="3"
                                                                        x="11"
                                                                        y="6.5"
                                                                        class=""
                                                                        style="overflow-wrap: break-word;"
                                                                    />
                                                                    <line
                                                                        fill="none"
                                                                        stroke-linecap="round"
                                                                        stroke-linejoin="round"
                                                                        stroke-miterlimit="10"
                                                                        x1="1"
                                                                        x2="11"
                                                                        y1="14.5"
                                                                        y2="14.5"
                                                                        class=""
                                                                        style="overflow-wrap: break-word;"
                                                                    />
                                                                    <line
                                                                        fill="none"
                                                                        stroke-linecap="round"
                                                                        stroke-linejoin="round"
                                                                        stroke-miterlimit="10"
                                                                        x1="6"
                                                                        x2="6"
                                                                        y1=".5"
                                                                        y2="3"
                                                                        class=""
                                                                        style="overflow-wrap: break-word;"
                                                                    />
                                                                    <line
                                                                        fill="none"
                                                                        stroke-linecap="round"
                                                                        stroke-linejoin="round"
                                                                        stroke-miterlimit="10"
                                                                        x1="3.5"
                                                                        x2="3.5"
                                                                        y1="1"
                                                                        y2="3"
                                                                        class=""
                                                                        style="overflow-wrap: break-word;"
                                                                    />
                                                                    <line
                                                                        fill="none"
                                                                        stroke-linecap="round"
                                                                        stroke-linejoin="round"
                                                                        stroke-miterlimit="10"
                                                                        x1="8.5"
                                                                        x2="8.5"
                                                                        y1="1"
                                                                        y2="3"
                                                                        class=""
                                                                        style="overflow-wrap: break-word;"
                                                                    />
                                                                </g>
                                                            </svg>
                                                        </div>
                                                        <img
                                                            alt=""
                                                            src={product.image}
                                                            class="absolute top-0 left-0 w-full h-full bg-no-repeat bg-cover"
                                                        />
                                                    </div>
                                                </div>
                                                <div
                                                    class="flex relative flex-col flex-grow items-start pointer-events-none"
                                                    style="min-width: 0px; overflow-wrap: break-word;"
                                                >
                                                    <div
                                                        class="overflow-hidden mb-1 w-full text-base"
                                                        style="display: -webkit-box; text-overflow: ellipsis; max-height: 2rem; overflow-wrap: break-word;"
                                                    >
                                                        {product.productId}
                                                        {product.productName}
                                                    </div>
                                                    <div
                                                        class="text-gray-600"
                                                        style="overflow-wrap: break-word;"
                                                    >
                                                        ราคาต่อชิ้น ฿{product.price -
                                                            (product.price *
                                                                product.discount) /
                                                                100}
                                                    </div>
                                                    <div
                                                        class=""
                                                        style="overflow-wrap: break-word;"
                                                    >
                                                        x {product.amount}
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div
                                            class="flex flex-col flex-none justify-center items-end py-0 pr-0 pl-2 w-32 border-r-0 box-border"
                                            style="overflow-wrap: break-word;"
                                        >
                                            <div
                                                class="flex flex-col"
                                                style="overflow-wrap: break-word;"
                                            >
                                                <div
                                                    class="text-red-600"
                                                    style="overflow-wrap: break-word;"
                                                >
                                                    {numberWithCommas(
                                                        product.sumPrice
                                                    )}
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            {/each}
                        </div>
                    </div>
                </div>

                <div class="py-0 px-6 leading-4 text-gray-800 bg-white">
                    <div
                        class="flex justify-end items-end pt-10 text-gray-800 p-10 border-t border-gray-400"
                    >
                        <span class="mr-2 text-sm leading-5">
                            ยอดคำสั่งซื้อทั้งหมด:
                        </span><span class="text-3xl leading-8 text-red-600">
                            ฿{numberWithCommas(billOrder.sumPriceBill)}</span
                        >
                    </div>
                    <div class="flex justify-end">
                        <button
                            on:click={() => printBill(billOrder)}
                            class="px-3 py-2 bg-blue-500 text-white"
                            >พิมพ์ใบสั่งซื้อ</button
                        >
                    </div>
                </div>
            </div>
        {/each}
    {:else}
        <div class="flex justify-center mx-auto my-auto items-center flex-col">
            <p>รายการว่าง</p>
        </div>
    {/if}
</div>
